## ableton-link 3.1.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(Link)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

#   ___        _   _
#  / _ \ _ __ | |_(_) ___  _ __  ___
# | | | | '_ \| __| |/ _ \| '_ \/ __|
# | |_| | |_) | |_| | (_) | | | \__ \
#  \___/| .__/ \__|_|\___/|_| |_|___/
#       |_|

# Note: Please use the LINK_* prefix for all project-specific options

if(UNIX)
  option(LINK_ENABLE_ASAN "Build with Address Sanitizier (ASan)" OFF)
  option(LINK_BUILD_JACK "Build example applications with JACK support" OFF)
endif()

if(WIN32)
  option(LINK_BUILD_ASIO "Build example applications with ASIO driver" ON)
  option(LINK_BUILD_VLD "Build with VLD support (VLD must be installed separately)" OFF)
endif()

option(LINK_BUILD_TESTS "Build unit test binaries" ON)

#  ____       _   _
# |  _ \ __ _| |_| |__  ___
# | |_) / _` | __| '_ \/ __|
# |  __/ (_| | |_| | | \__ \
# |_|   \__,_|\__|_| |_|___/
#

# Other CMake files must be included only after declaring build options
include(cmake_include/ConfigureCompileFlags.cmake)
include(cmake_include/CatchConfig.cmake)
include(AbletonLinkConfig.cmake)
include(extensions/abl_link/abl_link.cmake)

add_subdirectory(include)
if(LINK_BUILD_TESTS)
add_subdirectory(src)
endif()
add_subdirectory(examples)
add_subdirectory(extensions/abl_link)

#  ____
# / ___| _   _ _ __ ___  _ __ ___   __ _ _ __ _   _
# \___ \| | | | '_ ` _ \| '_ ` _ \ / _` | '__| | | |
#  ___) | |_| | | | | | | | | | | | (_| | |  | |_| |
# |____/ \__,_|_| |_| |_|_| |_| |_|\__,_|_|   \__, |
#                                             |___/

message(STATUS "Build options")

get_cmake_property(all_variables VARIABLES)
string(REGEX MATCHALL "(^|;)LINK_[A-Z_]+" link_variables "${all_variables}")
foreach(variable ${link_variables})
  message("   ${variable}: ${${variable}}")
endforeach()

message(STATUS "Build configuration")

if(CMAKE_BUILD_TYPE)
  message("   Build type: ${CMAKE_BUILD_TYPE}")
else()
  message("   Build type: Set by IDE")
endif()

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(LinkExamples)

#     _    ____ ___ ___
#    / \  / ___|_ _/ _ \
#   / _ \ \___ \| | | | |
#  / ___ \ ___) | | |_| |
# /_/   \_\____/___\___/
#

if(WIN32)
  function(configure_asio asio_sdk_path_OUT)
    # ASIO-related path/file variables
    set(asio_download_root "https://download.steinberg.net/sdk_downloads")
    set(asio_file_name "asiosdk_2.3.3_2019-06-14.zip")
    set(asio_dir_name "asiosdk_2.3.3_2019-06-14")
    set(asio_working_dir "${CMAKE_BINARY_DIR}/modules")
    set(asio_output_path "${asio_working_dir}/${asio_file_name}")

    message(STATUS "Downloading ASIO SDK")
    file(DOWNLOAD "${asio_download_root}/${asio_file_name}" ${asio_output_path})
    file(SHA1 ${asio_output_path} asio_zip_hash)
    message("   ASIO SDK SHA1: ${asio_zip_hash}")

    message("   Extracting ASIO SDK")
    execute_process(COMMAND ${CMAKE_COMMAND} -E tar "xf" ${asio_output_path} --format=zip
      WORKING_DIRECTORY ${asio_working_dir}
      INPUT_FILE ${asio_output_path}
    )

    # Set the ASIO SDK path for the caller
    set(${asio_sdk_path_OUT} "${asio_working_dir}/${asio_dir_name}" PARENT_SCOPE)
  endfunction()
endif()

#     _             _ _
#    / \  _   _  __| (_) ___
#   / _ \| | | |/ _` | |/ _ \
#  / ___ \ |_| | (_| | | (_) |
# /_/   \_\__,_|\__,_|_|\___/
#

set(linkhut_audio_SOURCES)

if(APPLE)
  set(linkhut_audio_SOURCES
    linkaudio/AudioPlatform_CoreAudio.hpp
    linkaudio/AudioPlatform_CoreAudio.cpp
  )
elseif(WIN32)
  if(LINK_BUILD_ASIO)
    configure_asio(asio_sdk_path)

    include_directories(${asio_sdk_path}/common)
    include_directories(${asio_sdk_path}/host)
    include_directories(${asio_sdk_path}/host/pc)

    set(linkhut_audio_SOURCES
      ${asio_sdk_path}/common/asio.cpp
      ${asio_sdk_path}/host/asiodrivers.cpp
      ${asio_sdk_path}/host/pc/asiolist.cpp
      linkaudio/AudioPlatform_Asio.hpp
      linkaudio/AudioPlatform_Asio.cpp
    )
  else()
    message(WARNING "LinkHut has been configured to be built with the WASAPI audio "
      "driver. This driver is considered experimental and has problems with low-latency "
      "playback. Please consider using the ASIO driver instead.")
    set(linkhut_audio_SOURCES
      linkaudio/AudioPlatform_Wasapi.hpp
      linkaudio/AudioPlatform_Wasapi.cpp
    )
  endif()
elseif(CMAKE_SYSTEM_NAME MATCHES "Linux|kFreeBSD|GNU")
  if(LINK_BUILD_JACK)
    set(linkhut_audio_SOURCES
      linkaudio/AudioPlatform_Jack.hpp
      linkaudio/AudioPlatform_Jack.cpp
    )
  else()
    set(linkhut_audio_SOURCES
      linkaudio/AudioPlatform_Portaudio.hpp
      linkaudio/AudioPlatform_Portaudio.cpp
    )
  endif()
endif()

include_directories(linkaudio)
source_group("Audio Sources" FILES ${linkhut_audio_SOURCES})

#   ____
#  / ___|___  _ __ ___  _ __ ___   ___  _ __
# | |   / _ \| '_ ` _ \| '_ ` _ \ / _ \| '_ \
# | |__| (_) | | | | | | | | | | | (_) | | | |
#  \____\___/|_| |_| |_|_| |_| |_|\___/|_| |_|
#

function(configure_linkhut_executable target)
  target_link_libraries(${target} Ableton::Link)
endfunction()

function(configure_linkhut_audio_sources target)
  if(APPLE)
    target_link_libraries(${target} "-framework AudioUnit")
    target_compile_definitions(${target} PRIVATE
      -DLINKHUT_AUDIO_PLATFORM_COREAUDIO=1
    )
  elseif(CMAKE_SYSTEM_NAME MATCHES "Linux|kFreeBSD|GNU")
    if(LINK_BUILD_JACK)
      target_link_libraries(${target} jack)
      target_compile_definitions(${target} PRIVATE
        -DLINKHUT_AUDIO_PLATFORM_JACK=1
      )
    else()
      target_link_libraries(${target} asound portaudio)
      target_compile_definitions(${target} PRIVATE
        -DLINKHUT_AUDIO_PLATFORM_PORTAUDIO=1
      )
    endif()
  elseif(WIN32)
    if(LINK_BUILD_ASIO)
      # ASIO uses lots of old-school string APIs from the C stdlib
      add_definitions("/D_CRT_SECURE_NO_WARNINGS")
      target_compile_definitions(${target} PRIVATE
        -DLINKHUT_AUDIO_PLATFORM_ASIO=1
      )
    else()
      target_compile_definitions(${target} PRIVATE
        -DLINKHUT_AUDIO_PLATFORM_WASAPI=1
      )
      endif()

    target_link_libraries(${target} winmm)
  endif()

endfunction()

if(WIN32)
  # When building LinkHut, additional warnings are generated from third-party frameworks
  set(extra_ignored_warnings_LIST
    "/wd4127" # conditional expression is constant
    "/wd4242" # 'identifier' : conversion from 'type1' to 'type2', possible loss of data
    "/wd4619" # #pragma warning : there is no warning number 'number'
    "/wd4668" # 'symbol' is not defined as a preprocessor macro, replacing with '0' for 'directives'
    "/wd4702" # unreachable code
    "/wd4946" # reinterpret_cast used between related classes: 'class1' and 'class2'
  )
  if(LINK_BUILD_ASIO)
    set(extra_ignored_warnings_LIST
      ${extra_ignored_warnings_LIST}
      "/wd4267" # 'argument': conversion from '?' to '?', possible loss of data
      "/wd4477" # 'printf': format string '%?' requires an argument of type '?'
    )
  else()
    set(extra_ignored_warnings_LIST
      ${extra_ignored_warnings_LIST}
      "/wd4191" # 'operator/operation' : unsafe conversion from 'type of expression' to 'type required'
    )
  endif()
  string(REPLACE ";" " " extra_ignored_warnings "${extra_ignored_warnings_LIST}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${extra_ignored_warnings}")
endif()

#  _     _       _    _   _       _
# | |   (_)_ __ | | _| | | |_   _| |_
# | |   | | '_ \| |/ / |_| | | | | __|
# | |___| | | | |   <|  _  | |_| | |_
# |_____|_|_| |_|_|\_\_| |_|\__,_|\__|
#

set(linkhut_HEADERS
  linkaudio/AudioEngine.hpp
  linkaudio/AudioPlatform.hpp
  ${link_HEADERS}
)

set(linkhut_SOURCES
  linkaudio/AudioEngine.cpp
  linkhut/main.cpp
)

add_executable(LinkHut
  ${linkhut_HEADERS}
  ${linkhut_SOURCES}
  ${linkhut_audio_SOURCES}
)
configure_linkhut_audio_sources(LinkHut)
configure_linkhut_executable(LinkHut)
source_group("LinkHut" FILES ${linkhut_HEADERS} ${linkhut_SOURCES})

#  _     _       _    _   _       _   ____  _ _            _
# | |   (_)_ __ | | _| | | |_   _| |_/ ___|(_) | ___ _ __ | |_
# | |   | | '_ \| |/ / |_| | | | | __\___ \| | |/ _ \ '_ \| __|
# | |___| | | | |   <|  _  | |_| | |_ ___) | | |  __/ | | | |_
# |_____|_|_| |_|_|\_\_| |_|\__,_|\__|____/|_|_|\___|_| |_|\__|
#

set(linkhutsilent_HEADERS
  linkaudio/AudioEngine.hpp
  linkaudio/AudioPlatform_Dummy.hpp
  ${link_HEADERS}
)

set(linkhutsilent_SOURCES
  linkaudio/AudioEngine.cpp
  linkhut/main.cpp
)

add_executable(LinkHutSilent
  ${linkhutsilent_HEADERS}
  ${linkhutsilent_SOURCES}
)

target_compile_definitions(LinkHutSilent PRIVATE
  -DLINKHUT_AUDIO_PLATFORM_DUMMY=1
)

configure_linkhut_executable(LinkHutSilent)
source_group("LinkHutSilent" FILES ${linkhutsilent_HEADERS} ${linkhutsilent_SOURCES})

=== include/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(LinkCore)

#   ____
#  / ___|___  _ __ ___
# | |   / _ \| '__/ _ \
# | |__| (_) | | |  __/
#  \____\___/|_|  \___|
#

set(link_core_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton/link)
set(link_core_HEADERS
  ${link_core_DIR}/Beats.hpp
  ${link_core_DIR}/ClientSessionTimelines.hpp
  ${link_core_DIR}/Controller.hpp
  ${link_core_DIR}/Gateway.hpp
  ${link_core_DIR}/GhostXForm.hpp
  ${link_core_DIR}/HostTimeFilter.hpp
  ${link_core_DIR}/LinearRegression.hpp
  ${link_core_DIR}/Measurement.hpp
  ${link_core_DIR}/MeasurementEndpointV4.hpp
  ${link_core_DIR}/MeasurementEndpointV6.hpp
  ${link_core_DIR}/MeasurementService.hpp
  ${link_core_DIR}/Median.hpp
  ${link_core_DIR}/NodeId.hpp
  ${link_core_DIR}/NodeState.hpp
  ${link_core_DIR}/PayloadEntries.hpp
  ${link_core_DIR}/Optional.hpp
  ${link_core_DIR}/Peers.hpp
  ${link_core_DIR}/PeerState.hpp
  ${link_core_DIR}/Phase.hpp
  ${link_core_DIR}/PingResponder.hpp
  ${link_core_DIR}/SessionId.hpp
  ${link_core_DIR}/SessionState.hpp
  ${link_core_DIR}/Sessions.hpp
  ${link_core_DIR}/StartStopState.hpp
  ${link_core_DIR}/Tempo.hpp
  ${link_core_DIR}/Timeline.hpp
  ${link_core_DIR}/TripleBuffer.hpp
  ${link_core_DIR}/v1/Messages.hpp
  PARENT_SCOPE
)

#  ____  _
# |  _ \(_)___  ___ _____   _____ _ __ _   _
# | | | | / __|/ __/ _ \ \ / / _ \ '__| | | |
# | |_| | \__ \ (_| (_) \ V /  __/ |  | |_| |
# |____/|_|___/\___\___/ \_/ \___|_|   \__, |
#                                      |___/

set(link_discovery_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton/discovery)
set(link_discovery_HEADERS
  ${link_discovery_DIR}/AsioTypes.hpp
  ${link_discovery_DIR}/InterfaceScanner.hpp
  ${link_discovery_DIR}/IpInterface.hpp
  ${link_discovery_DIR}/MessageTypes.hpp
  ${link_discovery_DIR}/NetworkByteStreamSerializable.hpp
  ${link_discovery_DIR}/Payload.hpp
  ${link_discovery_DIR}/PeerGateway.hpp
  ${link_discovery_DIR}/PeerGateways.hpp
  ${link_discovery_DIR}/Service.hpp
  ${link_discovery_DIR}/UdpMessenger.hpp
  ${link_discovery_DIR}/v1/Messages.hpp
  PARENT_SCOPE
)

#  ____  _       _    __
# |  _ \| | __ _| |_ / _| ___  _ __ _ __ ___
# | |_) | |/ _` | __| |_ / _ \| '__| '_ ` _ \
# |  __/| | (_| | |_|  _| (_) | |  | | | | | |
# |_|   |_|\__,_|\__|_|  \___/|_|  |_| |_| |_|
#

set(link_platform_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton/platforms)
set(link_platform_HEADERS
  ${link_platform_DIR}/Config.hpp
  ${link_platform_DIR}/asio/AsioTimer.hpp
  ${link_platform_DIR}/asio/AsioWrapper.hpp
  ${link_platform_DIR}/asio/Context.hpp
  ${link_platform_DIR}/asio/LockFreeCallbackDispatcher.hpp
  ${link_platform_DIR}/asio/Socket.hpp
)

if(ESP_PLATFORM)
  set(link_platform_HEADERS
    ${link_platform_HEADERS}
    ${link_platform_DIR}/esp32/Clock.hpp
    ${link_platform_DIR}/esp32/Context.hpp
    ${link_platform_DIR}/esp32/Esp32.hpp
    ${link_platform_DIR}/esp32/Random.hpp
    ${link_platform_DIR}/esp32/ScanIpIfAddrs.hpp
  )
elseif(UNIX)
  set(link_platform_HEADERS
    ${link_platform_HEADERS}
    ${link_platform_DIR}/posix/ScanIpIfAddrs.hpp
  )

  if(APPLE)
    set(link_platform_HEADERS
      ${link_platform_HEADERS}
      ${link_platform_DIR}/darwin/Clock.hpp
      ${link_platform_DIR}/darwin/Darwin.hpp
      ${link_platform_DIR}/darwin/ThreadFactory.hpp
      ${link_platform_DIR}/stl/Random.hpp
    )
  elseif(CMAKE_SYSTEM_NAME MATCHES "Linux|kFreeBSD|GNU")
    set(link_platform_HEADERS
      ${link_platform_HEADERS}
      ${link_platform_DIR}/linux/Clock.hpp
      ${link_platform_DIR}/linux/Linux.hpp
      ${link_platform_DIR}/stl/Clock.hpp
      ${link_platform_DIR}/stl/Random.hpp
      )
      if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
        set(link_platform_HEADERS
          ${link_platform_HEADERS}
          ${link_platform_DIR}/linux/ThreadFactory.hpp
          )
      endif()
  endif()
elseif(WIN32)
  set(link_platform_HEADERS
    ${link_platform_HEADERS}
    ${link_platform_DIR}/stl/Random.hpp
    ${link_platform_DIR}/windows/Clock.hpp
    ${link_platform_DIR}/windows/ScanIpIfAddrs.hpp
    ${link_platform_DIR}/windows/ThreadFactory.hpp
    ${link_platform_DIR}/windows/Windows.hpp
  )
endif()
set(link_platform_HEADERS
  ${link_platform_HEADERS}
  PARENT_SCOPE
)

#  _   _ _   _ _
# | | | | |_(_) |
# | | | | __| | |
# | |_| | |_| | |
#  \___/ \__|_|_|
#

set(link_util_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton/util)
set(link_util_HEADERS
  ${link_util_DIR}/Injected.hpp
  ${link_util_DIR}/Log.hpp
  ${link_util_DIR}/SafeAsyncHandler.hpp
  ${link_util_DIR}/SampleTiming.hpp
  PARENT_SCOPE
)

#  _____                       _           _
# | ____|_  ___ __   ___  _ __| |_ ___  __| |
# |  _| \ \/ / '_ \ / _ \| '__| __/ _ \/ _` |
# | |___ >  <| |_) | (_) | |  | ||  __/ (_| |
# |_____/_/\_\ .__/ \___/|_|   \__\___|\__,_|
#            |_|

# This list contains all of the headers needed by most Link projects.
# Usually, just adding this variable to your linker targets will place
# all relevant Link headers in your project.
set(link_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton)
set(link_HEADERS
  ${link_core_HEADERS}
  ${link_discovery_HEADERS}
  ${link_platform_HEADERS}
  ${link_util_HEADERS}
  ${link_DIR}/Link.hpp
  ${link_DIR}/Link.ipp
  PARENT_SCOPE
)

set(link_test_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ableton/test)
set(link_test_HEADERS
  ${link_discovery_DIR}/test/Interface.hpp
  ${link_discovery_DIR}/test/PayloadEntries.hpp
  ${link_discovery_DIR}/test/Socket.hpp
  ${link_util_DIR}/test/IoService.hpp
  ${link_util_DIR}/test/Timer.hpp
  ${link_test_DIR}/CatchWrapper.hpp
  ${link_test_DIR}/serial_io/Context.hpp
  ${link_test_DIR}/serial_io/Fixture.hpp
  ${link_test_DIR}/serial_io/SchedulerTree.hpp
  ${link_test_DIR}/serial_io/Timer.hpp
  PARENT_SCOPE
)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(LinkTest)

#  ____
# / ___|  ___  _   _ _ __ ___ ___  ___
# \___ \ / _ \| | | | '__/ __/ _ \/ __|
#  ___) | (_) | |_| | | | (_|  __/\__ \
# |____/ \___/ \__,_|_|  \___\___||___/
#

set(link_discovery_test_SOURCES
  ableton/discovery/tst_InterfaceScanner.cpp
  ableton/discovery/tst_Payload.cpp
  ableton/discovery/tst_PeerGateway.cpp
  ableton/discovery/tst_PeerGateways.cpp
  ableton/discovery/tst_UdpMessenger.cpp
  ableton/discovery/v1/tst_Messages.cpp
)

set(link_core_test_SOURCES
  ableton/link/tst_Beats.cpp
  ableton/link/tst_ClientSessionTimelines.cpp
  ableton/link/tst_Controller.cpp
  ableton/link/tst_HostTimeFilter.cpp
  ableton/link/tst_LinearRegression.cpp
  ableton/link/tst_Measurement.cpp
  ableton/link/tst_Median.cpp
  ableton/link/tst_Peers.cpp
  ableton/link/tst_PeerState.cpp
  ableton/link/tst_Phase.cpp
  ableton/link/tst_PingResponder.cpp
  ableton/link/tst_StartStopState.cpp
  ableton/link/tst_Tempo.cpp
  ableton/link/tst_Timeline.cpp
  ableton/link/tst_TripleBuffer.cpp
  ableton/tst_Link.cpp
)

set(link_test_SOURCES
  ableton/test/catch/CatchMain.cpp
  ableton/test/serial_io/SchedulerTree.cpp
)

#  ____                              ____
# / ___|  ___  _   _ _ __ ___ ___   / ___|_ __ ___  _   _ _ __  ___
# \___ \ / _ \| | | | '__/ __/ _ \ | |  _| '__/ _ \| | | | '_ \/ __|
#  ___) | (_) | |_| | | | (_|  __/ | |_| | | | (_) | |_| | |_) \__ \
# |____/ \___/ \__,_|_|  \___\___|  \____|_|  \___/ \__,_| .__/|___/
#                                                        |_|

source_group("Link" FILES
  ${link_core_HEADERS}
)

source_group("Discovery" FILES
  ${link_discovery_HEADERS}
)

source_group("Platform" FILES
  ${link_platform_HEADERS}
)

source_group("Util" FILES
  ${link_util_HEADERS}
)

source_group("Test Utils" FILES
  ${link_test_HEADERS}
  ${link_test_SOURCES}
)

#  _____                    _
# |_   _|_ _ _ __ __ _  ___| |_  ___
#   | |/ _` | '__/ _` |/ _ \ __|/ __|
#   | | (_| | | | (_| |  __/ |_ \__ \
#   |_|\__,_|_|  \__, |\___|\__||___/
#                |___/

function(configure_link_test_executable target)
  target_link_libraries(${target} Catch::Catch Ableton::Link)
  target_compile_definitions(${target} PRIVATE -DCATCH_CONFIG_ENABLE_BENCHMARKING=1)
endfunction()

# For the LinkCore test suite, we add header dependencies individually so that
# the source groups above are shown correctly to the project. However, most
# other projects integrating Link won't need this functionality, and they should
# should just depend on ${link_HEADERS}.
add_executable(LinkCoreTest
  ${link_core_HEADERS}
  ${link_discovery_HEADERS}
  ${link_platform_HEADERS}
  ${link_util_HEADERS}
  ${link_test_HEADERS}

  ${link_core_test_SOURCES}
  ${link_test_SOURCES}
)
configure_link_test_executable(LinkCoreTest)

# For the LinkDiscovery test suite, we only add dependencies on the headers
# necessary to compile these tests, since the Discovery feature should not have
# dependencies on the Link core code.  Normal targets should always use
# ${link_HEADERS} for their dependencies.
add_executable(LinkDiscoveryTest
  ${link_discovery_HEADERS}
  ${link_platform_HEADERS}
  ${link_util_HEADERS}
  ${link_test_HEADERS}

  ${link_discovery_test_SOURCES}
  ${link_test_SOURCES}
)
configure_link_test_executable(LinkDiscoveryTest)

=== examples/esp32/main/CMakeLists.txt ===
idf_component_register(SRCS main.cpp)

if(NOT DEFINED LINK_ESP_TASK_CORE_ID)
  set(LINK_ESP_TASK_CORE_ID tskNO_AFFINITY)
endif()
target_compile_definitions(${COMPONENT_LIB} PRIVATE LINK_ESP_TASK_CORE_ID=${LINK_ESP_TASK_CORE_ID})

target_compile_options(${COMPONENT_LIB} PRIVATE -fexceptions)

include(../../../AbletonLinkConfig.cmake)
target_link_libraries(${COMPONENT_TARGET} Ableton::Link)

=== debian/changelog ===
ableton-link (3.1.2+dfsg-1) unstable; urgency=medium

  * New upstream version 3.1.2+dfsg
  * Bump standards version to 4.7.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 15 Jul 2024 23:53:55 +0200

=== debian/control ===
Source: ableton-link
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 catch2 (>= 3~) <!nocheck>,
 cmake,
 debhelper-compat (= 13),
 libasio-dev,
 libjack-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://www.ableton.com/en/link/
Vcs-Git: https://salsa.debian.org/multimedia-team/ableton-link.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/ableton-link

Package: ableton-link-dev
Architecture: all
Multi-Arch: foreign
Depends:
 libasio-dev,
 ${misc:Depends},
Description: synchronizes musical applications on multiple devices - development
 Ableton Link, a technology that synchronizes musical beat, tempo, and phase
 across multiple applications running on one or more devices. Applications on
 devices connected to a local network discover each other automatically and form
 a musical session in which each participant can perform independently: anyone
 can start or stop while still staying in time. Anyone can change the tempo, the
 others will follow. Anyone can join or leave without disrupting the session.
 .
 Ableton Link is implemented as a header-only C++-library.
 This package contains the development files.

Package: ableton-link-utils
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: synchronizes musical applications on multiple devices - cmdline utils
 Ableton Link, a technology that synchronizes musical beat, tempo, and phase
 across multiple applications running on one or more devices. Applications on
 devices connected to a local network discover each other automatically and form
 a musical session in which each participant can perform independently: anyone
 can start or stop while still staying in time. Anyone can change the tempo, the
 others will follow. Anyone can join or leave without disrupting the session.
 .
 This package contains cmdline utilities to check synchronisation.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CONFIGURE_FLAGS = -DLINK_BUILD_JACK=ON

ifneq ($(filter nocheck,$(DEB_BUILD_PROFILES)),)
CONFIGURE_FLAGS += -DLINK_BUILD_TESTS=OFF
else
CONFIGURE_FLAGS += -DLINK_BUILD_TESTS=ON
endif


# workaround for https://gcc.gnu.org/bugzilla/show_bug.cgi?id=81358
ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mipsel powerpc riscv64 sh4))
export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		$(CONFIGURE_FLAGS)

execute_after_dh_install-indep:
	find $(CURDIR)/debian/ableton-link-dev/usr/share -name "*.cmake" -exec \
		sed -e 's|$${CMAKE_CURRENT_LIST_DIR}/include|/usr/include|g' -i {} +

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

=== debian/tests/control ===
Tests: build-examples-cmake
Depends:
 ableton-link-dev,
 build-essential,
 cmake,
 portaudio19-dev,
Restrictions: allow-stderr
